mode(-1);

rand("seed",123);
tol = 1e-12;
q = 4;

// full rank
for k = 1:100 do
  // real case
  X = rand(q,q);
  Y = rand(q,q);
  Y = Y + Y';
  Z = cplxlyap(X,Y);
  if norm(X'*Z*X-Z-Y)>tol then
    error("test failed!");
  end
  // complex case
  X = rand(q,q) + %i*rand(q,q);
  Y = rand(q,q) + %i*rand(q,q);
  Y = Y + Y';
  Z = cplxlyap(X,Y);
  if norm(X'*Z*X-Z-Y)>tol then
    error("test failed!");
  end
end

// rank deficient
for k = 1:100 do
  // real case
  X = rand(q,1)*rand(1,q);
  Y = rand(q,1)*rand(1,q);
  Y = Y + Y';
  Z = cplxlyap(X,Y);
  if norm(X'*Z*X-Z-Y)>tol then
    error("test failed!");
  end
  // complex case
  X = (rand(q,1) + %i*rand(q,1))*(rand(1,q) + %i*rand(1,q));
  Y = (rand(q,1) + %i*rand(q,1))*(rand(1,q) + %i*rand(1,q));
  Y = Y + Y';
  Z = cplxlyap(X,Y);
  if norm(X'*Z*X-Z-Y)>tol then
    error("test failed!");
  end
end
